#include <stdio.h>
#include <time.h>
#include <windows.h>
#include <commctrl.h>
#include "main.h"
#include "dialog1.h"
#include "dialog2.h"
#include "dialog3.h"
#include "dialog4.h"

HINSTANCE g_hInst;
HWND g_hWnd,g_hwndStatus,g_hWndUp,g_hWndDown,g_hWndLeft,g_hWndRight;
int paintcount,ColumnCount=0,LineCount=0,Zoom=360,Pairmode=0,
    littlestep=3600,bigstep=3600*24,aktstift=-1,KlickX,
    Stackpointer=0,Stackfuel=0;

float Scale=60,offset=0;
FILE *datei=0;
time_t Startzeit,Endzeit,Aktzeit;

struct
 {
 char name[320];
 char einheit[32];
 COLORREF farbe;
 int aktiv;
 double letzter;
 }
 ColRec, *Spalten=0;


struct {
         time_t Aktzeit;
         float offset,Scale;
         int Zoom;
        } ViewStack[256];

         
int ViewPush(void)
 {
 Stackfuel++;
 if(Stackfuel>256) Stackfuel--; /* Stack schon voll: alte Werte berschreiben */
 ViewStack[Stackpointer].Aktzeit=Aktzeit;
 ViewStack[Stackpointer].Scale=Scale;
 ViewStack[Stackpointer].offset=offset;
 ViewStack[Stackpointer].Zoom=Zoom;
 Stackpointer++;
 if(Stackpointer>255) Stackpointer=0;
 }
 
int ViewPop(void)
 {
 /* gespeicherte Fensterposition restaurieren */
 if(!Stackfuel) return 0; /* nix zu poppen */
 Stackfuel--;
 Stackpointer--;
 if(Stackpointer<0) Stackpointer=255;
 Aktzeit=ViewStack[Stackpointer].Aktzeit;
 Scale=ViewStack[Stackpointer].Scale;
 offset=ViewStack[Stackpointer].offset;
 Zoom=ViewStack[Stackpointer].Zoom;
 InvalidateRect(g_hWnd,0,TRUE);
 }

int Center(float Faktor)
 {
              char st1[200];
              int a;
              time_t Mitte;
              RECT rcClient;
              
              ViewPush(); /* Ansicht speichern */

              /* Uhrzeit der Klickpos errechnen */
              Mitte=Aktzeit+((KlickX-60)*Zoom);

              /* Ansichtsgre verdoppeln */
              Zoom /=Faktor; 
              if(Zoom<1) Zoom=1;

              /* nutzbare Fensterbreite ermitteln */
	      GetClientRect(g_hWnd, &rcClient);
              a=(rcClient.right-60)/2*Zoom;
              Aktzeit=Mitte-a;
              InvalidateRect(g_hWnd,0,TRUE); 
 }
  


        /* Funktionsdeklarationen */

LRESULT CALLBACK WndProc (HWND, 
                          UINT, 
                          WPARAM,
                          LPARAM);

BOOL WINAPI Dialog1_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam);
                    
BOOL WINAPI Dialog2_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam);
                    
BOOL WINAPI Dialog3_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam);
                    
BOOL WINAPI Dialog4_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam);
                    


int Hilfe(void)
 {
 MessageBox(g_hWnd,"Pfeil links oder rechts: Verschieben horizontal um einen kleinen Schritt\n"
                   "<Strg>- Pfeil links oder rechts: um einen groen Schritt\n"
                   "Pfeil hoch oder runter: Verschieben vertikal um ein Zehntel"
 ,"Tastenbelegung",MB_OK);
 }

/* liefert den nchsten teilstring */
char *parse(char *cp)
 {
 char *cp2;
 cp+=strlen(cp);        /*jetzt zeigt er auf das NULL-Zeichen*/
 cp++;
 if(cp2=strchr(cp,';')) *cp2=0; /*Spaltentrennzeichen*/
 return cp;
 }


int FileClose()
 {
 if(datei)
  {
  Stackfuel=0;
  fclose(datei);
  datei=0;
  ColumnCount=0;
  if(Spalten) free(Spalten);
  SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) "keine Datei geladen!");             
  }
 return 0;
 }

int FileOpen(char *name)
 {
 char st1[1500],*cp,Datum1[20],Datum2[20];
 int a,jahr,monat,tag,stunde,minute,sekunde,Mantisse,Exponent;
 float x,minimum=1E20;
 SCROLLINFO si;
 struct tm *tmBuf,t;
 time_t t1;

 if(datei) 
  {
   FileClose();
  }
 datei=fopen(name,"r");
 if(!datei)
  {
  MessageBox(0,"Datei konnte nicht geffnet werden","Fehler",MB_OK);
  return 0;
  }
 
 
 Endzeit=0;
 Startzeit=0x7fffffff;
 
 
 fgets(st1,1490,datei);
 if(cp=strchr(st1,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/
 if(cp=strchr(st1,';')) *cp=0;  /*erster Separator*/
 
 /* jetzt die Kopfzeile parsen (wie viele Spalten?) */
 cp=st1;
 if(strcmp(cp,"Datum"))
  {
  FileClose();
  MessageBox(0,"Datei hat falsches Format (Spalte 1 ungleich Datum)!",name,MB_OK);
  datei=0;
  return 0;
  }
 cp=parse(cp);
 if(strcmp(cp,"Zeit"))
  {
  FileClose();
  MessageBox(0,"Datei hat falsches Format (Spalte 2 ungleich Zeit)!",name,MB_OK);
  datei=0;
  return 0;
  }
 do
  {
  cp=parse(cp);
  ColumnCount++;
  }
 while (strlen(cp));
 ColumnCount--;
 Spalten=calloc(ColumnCount+1,sizeof(ColRec));
 
 /* Jetzt die Kpfe vorbereiten */
 cp=st1+strlen(st1)+1; /*Das war das Datum*/
 cp=cp+strlen(cp)+1; /*Das war die Uhrzeit*/
 for(a=0;a<ColumnCount;a++)
  {
  char *cp1;
  int farbe,rot,gruen,blau;
  float winkel;
  const float pi   = 3.1418;
  strcpy(Spalten[a].name,cp);
  strcpy(Spalten[a].einheit,"");
  winkel=2*pi*a/ColumnCount;
  rot=127*(1+sin(winkel));
  gruen=127*(1+sin(winkel+(pi/3*2)));
  blau=127*(1+sin(winkel+2*(pi/3*2)));
  if(rot<0) rot=0;
  if(gruen<0) gruen=0;
  if(blau<0) blau=0;
  Spalten[a].farbe=RGB(rot,gruen,blau);
  Spalten[a].aktiv=1;
  if(cp1=strchr(Spalten[a].name,'#'))
   {
   *cp1=0;
   cp1++;
   sscanf(cp1,"%x",&Spalten[a].farbe);
   if(cp1=strchr(cp1,'#'))
    {
    cp1++;
    sscanf(cp1,"%d",&Spalten[a].aktiv);
    if(cp1=strchr(cp1,'#'))
     {
     cp1++;
     strcpy(Spalten[a].einheit,cp1);
     }
    }
   }  
  cp=cp+strlen(cp)+1; /*weiterzhlen*/
  }
 Scale=0;
 SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) "Datei wird geladen, bitte warten!");             
 do
  {
   memset(st1,0,1490);
   memset(&t,0,sizeof(t));
   fgets(st1,1490,datei);
   cp=st1;
   /* Kommas durch Punkte ersetzen */
   while (cp=strchr(cp,',')) *cp='.';
   
   if(!feof(datei))
   {
   LineCount++;
   /* Maxima suchen */
   if(cp=strchr(st1,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/

   /* Zeitstempel lesen */
   sscanf(st1,"%d.%d.%d;%d:%d:%d",&t.tm_mday,&monat,&jahr,
				  &t.tm_hour,&t.tm_min,&t.tm_sec);
   t.tm_mon=monat-1;
   t.tm_year=jahr-1900;
   t.tm_isdst=-1;
   t1=mktime(&t);
   if (t1>Endzeit) Endzeit=t1;
   if (t1<Startzeit) Startzeit=t1;
 
   if(cp=strchr(st1,';')) *cp=0;  /*erster Separator*/
   cp=parse(st1);
   for(a=0;a<ColumnCount;a++)
     {
     cp=parse(cp); /*weiterzhlen*/
     sscanf(cp,"%f",&x);
     if(x>Scale) Scale=x;
     if(x<minimum) minimum=x;
     }
    }
  } 
  while(!feof(datei));
 rewind(datei); 

 /* Automatisch skalieren */
 if(minimum!=0)
 {
 sprintf(st1,"%E",minimum);
 sscanf(st1,"%d",&Mantisse);
 if(cp=strchr(st1,'E')) sscanf(cp+1,"%d",&Exponent);
 if(Mantisse>0) Mantisse++;
 else Mantisse--;
 sprintf(st1,"%d.0E%+d",Mantisse,Exponent);
 sscanf(st1,"%E",&offset);
 }

 sprintf(st1,"%E",Scale);
 sscanf(st1,"%d",&Mantisse);
 if(cp=strchr(st1,'E')) sscanf(cp+1,"%d",&Exponent);
 if(Mantisse>0) Mantisse++;
 else Mantisse--;
 sprintf(st1,"%d.0E%+d",Mantisse,Exponent);
 sscanf(st1,"%E",&Scale);


 Scale-=offset;


 if(Scale==0) Scale=1;
 Aktzeit=Startzeit;
 
 sprintf(st1,"%s - Ingos CSV-Viewer",name);
 SendMessage(g_hWnd,WM_SETTEXT,0,(LPARAM) st1);
 return 0;
 }



int Paint(HANDLE hdc, RECT rcClient)
 {
      		HPEN *Stifte,penalt,Schwarz,Grau;
      		HBRUSH brush,brushalt;
      		HFONT hfnt;
      		LOGFONT lf;
                struct tm t,*pTime;
                time_t t1,tneu,modul,delta;
                
		char st1[1500],*cp,*cp1,date[40],olddate[40],time[40];
		int alttag,altstunde,a,x,xscale,ystep,lastdate=0,lasttime=0,
		monat,jahr,raster,mod2;
		double v;
      		Stifte=calloc(ColumnCount,sizeof(HPEN));
      		for(a=0;a<ColumnCount;a++)
                 {
      		  if(a==aktstift) Stifte[a]=CreatePen(PS_SOLID,3,Spalten[a].farbe);
      		  else Stifte[a]=CreatePen(PS_SOLID,1,Spalten[a].farbe);
      		 }
                Schwarz=CreatePen(PS_SOLID,1,0);
                Grau=CreatePen(PS_SOLID,1,0xe0e0e0);
      		penalt=(HPEN)SelectObject(hdc,Schwarz);
      		      		
      		
		/* Die Palette ausgeben */
      		SetTextAlign(hdc,TA_LEFT); 
      		if(datei)
      		xscale=rcClient.right/(ColumnCount+1);



      		for (a=0;a<ColumnCount;a+=2)
      		 {
      		 SetTextColor(hdc,0x0);
                 if(Spalten[a].aktiv)
                  SetBkColor(hdc,Spalten[a].farbe);
                 else
                  SetBkColor(hdc,0xffffff);
                 if(strlen(Spalten[a].einheit))
                  sprintf(st1," %s (%s) ",Spalten[a].name,Spalten[a].einheit);
                 else sprintf(st1," %s ",Spalten[a].name);

       		 ZeroMemory(&lf,sizeof(LOGFONT));
      		 strcpy(lf.lfFaceName,"Courier New");
      		 lf.lfHeight=12;
      		 lf.lfWidth=10;
      		 if(aktstift==a) lf.lfWeight=FW_BLACK;
      		 else lf.lfWeight=FW_NORMAL;

      		 lf.lfEscapement=0;
      		 hfnt=CreateFontIndirect(&lf);
      		 SelectObject(hdc,hfnt);
      		 DeleteObject(hfnt);

      		 TextOut(hdc,4+xscale*a,rcClient.bottom-18,st1,strlen(st1));

                 if(Spalten[a+1].aktiv)
                   {
                   if(!Pairmode) SetBkColor(hdc,Spalten[a+1].farbe);
                   }
                 else
                  if(!Pairmode) SetBkColor(hdc,0xffffff);
                 if(strlen(Spalten[a+1].einheit))
                  sprintf(st1," %s (%s) ",Spalten[a+1].name,Spalten[a+1].einheit);
                 else sprintf(st1," %s ",Spalten[a+1].name);

       		 ZeroMemory(&lf,sizeof(LOGFONT));
      		 strcpy(lf.lfFaceName,"Courier New");
      		 lf.lfHeight=12;
      		 lf.lfWidth=10;
      		 if((aktstift==a+1)
      		    |(Pairmode&(aktstift==a))) lf.lfWeight=FW_BLACK;
      		 else lf.lfWeight=FW_NORMAL;
      		 lf.lfEscapement=0;
      		 hfnt=CreateFontIndirect(&lf);
      		 SelectObject(hdc,hfnt);
      		 DeleteObject(hfnt);

      		 TextOut(hdc,4+xscale*a,rcClient.bottom-5,st1,strlen(st1));
      		 }

                /* Die Y-Skala ausgeben */
       		ZeroMemory(&lf,sizeof(LOGFONT));
      		strcpy(lf.lfFaceName,"Courier New");
      		lf.lfHeight=12;
      		lf.lfWidth=10;
      		lf.lfWeight=FW_NORMAL;
      		lf.lfEscapement=0;
      		hfnt=CreateFontIndirect(&lf);
      		SelectObject(hdc,hfnt);
      		DeleteObject(hfnt);
      		
      		/* wie viele Skalenstriche wollen wir machen? */
                ystep=Scale*100;
                a=rcClient.bottom-rcClient.top-120; /* Nutzbare Pixel */

                while (20*ystep>a) ystep/=10;
                if (100*ystep<a) ystep*=5;
                if (40*ystep<a) ystep*=2;

                SelectObject(hdc,Grau); /* zum linien Zeichnen */
                SetBkColor(hdc,0xffffff);
                for(a=0;a<(ystep+1);a++)
                 {
                 v=Scale*a/ystep;
                 if(Pairmode) v*=2;
                 if(Scale>100) sprintf(st1,"%7.0lf",v+offset);
                 else sprintf(st1,"%6.2lf",v+offset);
      		 TextOut(hdc,2,rcClient.bottom-126-((rcClient.bottom-rcClient.top-120)*a/ystep),st1,strlen(st1));
      		 MoveToEx(hdc,60,rcClient.bottom-120-((rcClient.bottom-rcClient.top-120)*a/ystep),NULL);
      		 LineTo(hdc,rcClient.right,rcClient.bottom-120-((rcClient.bottom-rcClient.top-120)*a/ystep));
                 }

                raster=30;
                mod2=1;
                if(Zoom>1) raster=60;
                if(Zoom>3) raster=120;
                if(Zoom>4) raster=300;
                if(Zoom>12) raster=600; /* 10 Minuten */
                if(Zoom>24) raster=1200; /* 20 Minuten */
                if(Zoom>36) raster=1800; /* 30 Minuten */                
                if(Zoom>72) raster=3600; /* 1 Stunde */
		if(Zoom>144) mod2=2;
		if(Zoom>288) mod2=4;
		if(Zoom>432) mod2=6;

                /* Zeitachse zeichnen */
                alttag=32;
                delta=raster-(Aktzeit%raster);
                do
                 {
                 t1=Aktzeit+delta;
                 x=(t1-Aktzeit)/Zoom+60;
                 pTime=localtime(&t1);                                  
                  {
                   sprintf(time,"%02d:%02d:%02d",pTime->tm_hour,
                                               pTime->tm_min,
                                               pTime->tm_sec);
                   if(Zoom<1500) /* Darber brauchen wir keine Stundenbeschriftung */
                    {
                     if(!(pTime->tm_hour%mod2))
                      {
                      /* Zeitachsenbeschriftung zeichnen */
      		      HFONT hfnt;
      		      LOGFONT lf;
      		      ZeroMemory(&lf,sizeof(LOGFONT));
      		      strcpy(lf.lfFaceName,"Courier New");
      		      lf.lfHeight=12;
      		      lf.lfWidth=10;
      		      lf.lfWeight=FW_NORMAL;
      		      lf.lfEscapement=900;
      		      hfnt=CreateFontIndirect(&lf);
      		      SelectObject(hdc,hfnt);
                      DeleteObject(hfnt);
                      SetBkColor(hdc,0xffffff);
                      SetTextColor(hdc,0);
      		      TextOut(hdc,x-4,rcClient.bottom-38,time,strlen(time));
       		      SelectObject(hdc,Grau);
      		      MoveToEx(hdc,x,rcClient.bottom-120,NULL);
      		      LineTo(hdc,x,rcClient.top);
      		      }
      		    }
                  }

		 /* Datum ausgeben */
                 if((Zoom<6000)&&(pTime->tm_mday!=alttag))
                  {
                   sprintf(date,"%02d.%02d.",pTime->tm_mday,
                                               pTime->tm_mon+1);
      		   HFONT hfnt;
      		   LOGFONT lf;
      		   ZeroMemory(&lf,sizeof(LOGFONT));
      		   strcpy(lf.lfFaceName,"Courier New");
      		   lf.lfHeight=12;
      		   lf.lfWidth=10;
      		   lf.lfWeight=FW_NORMAL;
      		   lf.lfEscapement=0;
      		   if(Zoom>1499) lf.lfEscapement=900;
      		   hfnt=CreateFontIndirect(&lf);
      		   SelectObject(hdc,hfnt);
                   DeleteObject(hfnt);
                   SetBkColor(hdc,0xffffff);
                   SetTextColor(hdc,0);
    		   TextOut(hdc,x,rcClient.bottom-36,date,strlen(date));
       		   SelectObject(hdc,Schwarz);
       		   if(pTime->tm_mday>alttag)
       		    {
      		    MoveToEx(hdc,x,rcClient.bottom-120,NULL);
      		    LineTo(hdc,x,rcClient.top);
      		    }                  
                  }

                  alttag=pTime->tm_mday;
      		  delta+=raster;                  
                  } while (x<rcClient.right);


                SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) "Diagramm wird gezeichnet, bitte warten!");             
                /* Die Kurven Zeichnen */
                rewind (datei);
                fgets(st1,1490,datei); /* Die Kopfzeile haben wir schon */

                /* bis zur Startposition vorspulen */
                if(Aktzeit)
                do
                 {
                  memset(st1,0,100);
                  memset(&t,0,sizeof(t));
                  fgets(st1,1490,datei); /* eine Zeile einlesen */
		  /* Zeitstempel lesen */
		  sscanf(st1,"%d.%d.%d;%d:%d:%d",&t.tm_mday,&monat,&jahr,
				  &t.tm_hour,&t.tm_min,&t.tm_sec);
		  t.tm_mon=monat-1;
                  t.tm_year=jahr-1900;
                  t.tm_isdst=-1;
                
                  t1=mktime(&t);
                 }
                while ((t1<Aktzeit)&&(!feof(datei)));
		
		
                cp=st1;
                while (cp=strchr(cp,',')) *cp='.';
                if(cp=strchr(st1,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/
                if(cp=strchr(st1,';')) *cp=0;  /*erster Separator*/
                cp=st1;         /* das ist das Datum */
                cp=parse(cp);   /* das ist die Zeit */
                for(a=0;a<ColumnCount;a++)
                 {
                  cp=parse(cp);
                  sscanf(cp,"%lf",&v);
                  if(Pairmode)
                    {
                    double v2;
                    cp=parse(cp);
                    sscanf(cp,"%lf",&v2);
                    v=(v+v2)/2;
                    }                   
                  v-=offset;
                  v=v*(rcClient.bottom-rcClient.top-120)/Scale;
                  Spalten[a].letzter=v;
                  if(Pairmode) a++;
                 }

	        /* folgende Werte erfassen */
	        x=0;
                while ((x<rcClient.right)&&(!feof(datei)))
                 {                
                 memset(st1,0,1490);
                 memset(&t,0,sizeof(t));
                 fgets(st1,1490,datei); /* nchste Zeile einlesen */
                 if(!feof(datei))
                 {
 		 /* Zeitstempel lesen */
		 sscanf(st1,"%d.%d.%d;%d:%d:%d",&t.tm_mday,&monat,&jahr,
				  &t.tm_hour,&t.tm_min,&t.tm_sec);
		 t.tm_mon=monat-1;
                 t.tm_year=jahr-1900;
                  t.tm_isdst=-1;
                 tneu=mktime(&t);
                 if(tneu>Endzeit) Endzeit=tneu; /* Datei ist gewachsen */

                 cp=st1;
                 while (cp=strchr(cp,',')) *cp='.';
                 if(cp=strchr(st1,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/
                 if(cp=strchr(st1,';')) *cp=0;  /*erster Separator*/
                 cp=st1;         /* das ist das Datum */
                 strcpy(date,cp);
                 cp=parse(cp);   /* das ist die Zeit */
                 strcpy(time,cp);


                 for(a=0;a<ColumnCount;a++)
                  {
                   cp=parse(cp);
                   if(Spalten[a].aktiv)
                   {
                   sscanf(cp,"%lf",&v);
                   if(Pairmode)
                    {
                    double v2;
                    cp=parse(cp);
                    sscanf(cp,"%lf",&v2);
                    v=(v+v2)/2;
                    }
                   v-=offset;
                   v=v*(rcClient.bottom-rcClient.top-120);
                   v=v/Scale;
       		   SelectObject(hdc,Stifte[a]);
       		   x=60+((t1-Aktzeit)/Zoom);

      		   MoveToEx(hdc,x,rcClient.bottom-120
      		                    -(Spalten[a].letzter),NULL);
      		   x=60+((tneu-Aktzeit)/Zoom);

      		   LineTo(hdc,x,rcClient.bottom-120
      		                    -(v));
                   Spalten[a].letzter=v;
                   }
                   else
                   {
                   if(Pairmode)
                    {
                    double v2;
                    cp=parse(cp);
                    }                   
                   }
                   if(Pairmode) a++;
                  }
                  t1=tneu;
                  }
                 }

		SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) "bereit");             
		SelectObject(hdc,penalt);
                for(a=0;a<ColumnCount;a++)
      		DeleteObject(Stifte[a]);
      		DeleteObject(Schwarz);
      		DeleteObject(Grau);
      		DeleteObject(brush);
		free(Stifte); 
 return 0;
 }



#pragma argsused
int APIENTRY WinMain(HINSTANCE hInstance,
			HINSTANCE hPrevInstance,
			LPSTR	lpCmdLine,
			int	nCmdShow)
	{
	int left=0,top=0,right=800,bottom=600;
	char st1[300],*cp;
	FILE *datei;
	g_hInst=hInstance;
	InitCommonControls();
	WNDCLASS WndClass;
	WndClass.style =CS_OWNDC | CS_VREDRAW | CS_HREDRAW| CS_DBLCLKS;
	WndClass.cbClsExtra=0;	
	WndClass.cbWndExtra=0;
	WndClass.lpfnWndProc=WndProc;
	WndClass.hInstance=hInstance;	
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);	
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICON1));
	WndClass.lpszMenuName=MAKEINTRESOURCE(IDM_MENU1);
	WndClass.lpszClassName="WinProg";
	RegisterClass(&WndClass);
	

	/* Versuchen, inidatei einzusesen */
        GetEnvironmentVariable("USERPROFILE",st1,290);
        strcat(st1,"\\csv_view.ini");
        datei=fopen(st1,"r");
        if(datei)
         {
         if(fgets(st1,200,datei)) sscanf(st1,"%d\n",&left);
         if(fgets(st1,200,datei)) sscanf(st1,"%d\n",&right);
         if(fgets(st1,200,datei)) sscanf(st1,"%d\n",&top);
         if(fgets(st1,200,datei)) sscanf(st1,"%d\n",&bottom);
         if(fgets(st1,200,datei)) sscanf(st1,"%d\n",&littlestep);
         if(fgets(st1,200,datei)) sscanf(st1,"%d\n",&bigstep);
         if(fgets(st1,200,datei)) sscanf(st1,"%d\n",&Zoom);
         if(fgets(st1,200,datei)) sscanf(st1,"%d\n",&Pairmode);
	 fclose(datei);
	 }
	g_hWnd=CreateWindow("WinProg","keine Datei - Ingos CSV-Viewer",WS_OVERLAPPEDWINDOW,
				left,top,right-left,bottom-top,NULL,NULL,hInstance,NULL);
	ShowWindow(g_hWnd,nCmdShow);
	UpdateWindow((g_hWnd));
	
	MSG Message;
	while (GetMessage(&Message,NULL,0,0))
	 {
	 DispatchMessage(&Message);
	 TranslateMessage(&Message);
	 }
	 return(Message.wParam);	 
      }


LRESULT CALLBACK WndProc (HWND hWnd, UINT uiMessage,
					WPARAM wParam, LPARAM lParam)
	{

	  switch(uiMessage)
	  {
	   case WM_DESTROY:
	    {
	    char st1[300],*cp;
	    FILE *datei;
	    WINDOWPLACEMENT wp;
	    /* Einstellungen speichern */
            GetEnvironmentVariable("USERPROFILE",st1,290);
            strcat(st1,"\\csv_view.ini");
            datei=fopen(st1,"w");
	    GetWindowPlacement(hWnd,&wp);
	    fprintf(datei,"%d\n",wp.rcNormalPosition.left);
	    fprintf(datei,"%d\n",wp.rcNormalPosition.right);
	    fprintf(datei,"%d\n",wp.rcNormalPosition.top);
	    fprintf(datei,"%d\n",wp.rcNormalPosition.bottom);
	    fprintf(datei,"%d\n",littlestep);
	    fprintf(datei,"%d\n",bigstep);
	    fprintf(datei,"%d\n",Zoom);
	    fprintf(datei,"%d\n",Pairmode);
	    fclose(datei);
	    PostQuitMessage(0);
	    return 0;
	    }
	   case WM_CREATE:
	    { 
	     char st1[300],*cp,*cp1;

	     /* StatusBar erzeugen */
	     g_hwndStatus = CreateWindowEx( 
			0,                       // no extended styles 
			STATUSCLASSNAME,         // name of status window class 
			(LPCTSTR) NULL,          // no text when first created 
			SBARS_SIZEGRIP |         // includes a sizing grip 
			WS_VISIBLE |
			WS_CHILD,                // creates a child window 
			0, 0, 0, 0,              // ignores size and position 
			hWnd,              	      // handle to parent window 
			(HMENU) 0,       // child window identifier 
			g_hInst,                   // handle to application instance 
			NULL);                   // no window creation data 
              SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) "keine Datei geladen!");             

              g_hWndLeft=CreateWindow("BUTTON","<",WS_VISIBLE | WS_CHILD |BS_BITMAP,
                    10,440, 
                    20,20,
                    hWnd,
                    (HMENU) CM_LEFT,
                    (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE), 
                    NULL);

              g_hWndRight=CreateWindow("BUTTON",">",WS_VISIBLE | WS_CHILD|BS_BITMAP ,
                    30,440, 
                    20,20,
                    hWnd,
                    (HMENU) CM_RIGHT,
                    (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE), 
                    NULL);

              g_hWndUp=CreateWindow("BUTTON","^",WS_VISIBLE | WS_CHILD|BS_BITMAP ,
                    20,420, 
                    20,20,
                    hWnd,
                    (HMENU) CM_UP,
                    (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE), 
                    NULL);

              g_hWndDown=CreateWindow("BUTTON","v",WS_VISIBLE | WS_CHILD|BS_BITMAP ,
                    20,460, 
                    20,20,
                    hWnd,
                    (HMENU) CM_DOWN,
                    (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE), 
                    NULL);

              SendMessage(g_hWndLeft,BM_SETIMAGE,IMAGE_BITMAP,
                          (LPARAM) LoadBitmap((HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                                            (LPCTSTR) IDB_LEFT));
              SendMessage(g_hWndRight,BM_SETIMAGE,IMAGE_BITMAP,
                          (LPARAM) LoadBitmap((HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                                            (LPCTSTR) IDB_RIGHT));
              SendMessage(g_hWndUp,BM_SETIMAGE,IMAGE_BITMAP,
                          (LPARAM) LoadBitmap((HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                                            (LPCTSTR) IDB_UP));
              SendMessage(g_hWndDown,BM_SETIMAGE,IMAGE_BITMAP,
                          (LPARAM) LoadBitmap((HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                                            (LPCTSTR) IDB_DOWN));

	      /* Datei in der Kommandozeile angegeben? */
		strcpy(st1,GetCommandLine());
		if(cp=strstr(st1," /")) *cp=0;
		cp=st1;
		if(*cp=='"') /*erstes Gnsefsschen vom Programmnamen*/
		 {
		 cp=strchr(cp+1,'"'); /*zweites Gnsefsschen suchen*/
		 if(!cp) return 0;   /*kein schliessendes*/
		 cp++;
		 }
		else
		 {
		 cp=strchr(cp,' '); /* Knnen auch mehrere Leerzeichen sein */
		 } 
		/*Jetzt sollten wir den Programmnamen bersprungen haben*/ 
                if(!cp) return 0;

                while (*cp==' ') cp++; /*fllende Leerzeichen berspringen*/


                if(!strlen(cp)) return 0; /*kein Dateiname angegeben*/
                
		 
		if(*cp=='"')    /* Dateiname ist auch eingepackt! */
                 {
		 cp++;
		 if(cp1=strchr(cp,'"')) *cp1=0;
		 }
		FileOpen(cp);
		strcat(cp," - Ingos CSV-Viewer");
		SendMessage(hWnd,WM_SETTEXT,0,(LPARAM) cp);		
	     }
	     return 0;

	    case WM_SIZE:
	     {
             int i,nw,inc,width[10];
             char puffer[300],*cp;
	     RECT rcClient;
             GetClientRect(hWnd, &rcClient);
             //einfach an den StatusBar weitergeben
             SendMessage(g_hwndStatus,WM_SIZE,wParam,lParam);
             MoveWindow(g_hWndLeft,10,rcClient.bottom-120,20,20,TRUE);
             MoveWindow(g_hWndRight,30,rcClient.bottom-120,20,20,TRUE);
             MoveWindow(g_hWndUp,20,rcClient.bottom-140,20,20,TRUE);
             MoveWindow(g_hWndDown,20,rcClient.bottom-100,20,20,TRUE);

		strcpy(puffer,GetCommandLine());
		if(cp=strstr(puffer,"/TOTAL"));
                 {		
		  time_t laenge;
                  Aktzeit=Startzeit;
	          laenge=Endzeit-Startzeit;
	          /*Bildschirmgre ermitteln*/
                  Zoom=laenge/(rcClient.right-60);
		 }

	     }
	     return 0;
	      
	    case WM_PAINT:
	     {
      		PAINTSTRUCT ps;
      		HDC hdc;
      		RECT rcClient;

      		hdc=BeginPaint(hWnd,&ps);
      		if(!datei)
      		 {
      		 EndPaint(hWnd,&ps);
      		 return 0;
      		 }
      		
		GetClientRect(hWnd, &rcClient);
      		rcClient.left+=10;
		rcClient.top+=10;
		rcClient.bottom-=40;
		rcClient.right-=10;
		
                Paint(hdc,rcClient);
		ReleaseDC(hWnd,hdc);
      		EndPaint(hWnd,&ps);
	     }	
	    return 0;

            case WM_MOUSEMOVE:
             {
             char st1[100];
             int x,y;
             double v;
	     RECT rcClient;
             time_t t1;
             struct tm *pTime;
             
             if(!datei)
              {
              return 0;
              }
             x=LOWORD(lParam);
             y=HIWORD(lParam);

	     /* Fenstergre ermitteln */
	     GetClientRect(hWnd, &rcClient);
	     rcClient.bottom-=160; /* + 10 Punkte oberer Rand */

             t1=Aktzeit+((x-60)*Zoom);
             pTime=localtime(&t1);

	     v=(rcClient.bottom-y)*Scale/(rcClient.bottom-10);
	     v+=offset;
             sprintf(st1,"%02d.%02d.%04d, %02d:%02d:%02d --> Wert = %lf",pTime->tm_mday,
                                               pTime->tm_mon+1,
                                               pTime->tm_year+1900,
                                               pTime->tm_hour,
                                               pTime->tm_min,
                                               pTime->tm_sec,
                                               v);
             SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) st1);
             }
             return 0;

	    case WM_KEYDOWN:
	     {
	      char st1[40];

	     switch(wParam)
	      {
	      case VK_LEFT:
	       {
	       if(GetKeyState(VK_SHIFT)&0x80000000)
	        {
                /* Umchalt-Pfeillinks : zurck */
	        ViewPop();
	        }
	       else
                {
                ViewPush();	       
	        if((GetKeyState(VK_LCONTROL)&0x80000000)
	          ||(GetKeyState(VK_RCONTROL)&0x80000000)) Aktzeit-=bigstep;
	        else Aktzeit-=littlestep;
	        if(Aktzeit<Startzeit) Aktzeit=Startzeit;
                InvalidateRect(hWnd,0,TRUE);	       
                }
	       return 0;
	       }
	      case VK_RIGHT:
	       {
	       ViewPush();
	       if((GetKeyState(VK_LCONTROL)&0x80000000)
	          ||(GetKeyState(VK_RCONTROL)&0x80000000)) Aktzeit+=bigstep;

	       else Aktzeit+=littlestep;
	       if(Aktzeit>Endzeit) Aktzeit=Endzeit;
               InvalidateRect(hWnd,0,TRUE);	       
	       return 0;
	       }
	      case VK_UP:
	       {
	       ViewPush();
	       offset+=Scale/10;
	       
               InvalidateRect(hWnd,0,TRUE);	       
	       return 0;
	       }
	      case VK_DOWN:
	       {
	       ViewPush();  
	       offset-=Scale/10;
               InvalidateRect(hWnd,0,TRUE);	       
	       return 0;
	       }

	      case VK_F1:	/* Hillf */
	       {
	       Hilfe();
	       return 0;
	       }
	      }
	     return 0;
	     }

            case WM_RBUTTONDOWN:
             {
             char st1[200];
             int x,y,xscale;
             RECT rcClient;
             x=LOWORD(lParam);
             y=HIWORD(lParam);
             GetClientRect(hWnd,&rcClient);
             rcClient.left+=3;
             rcClient.top+=3;
             rcClient.bottom-=40;
             rcClient.right-=3;

             if(!datei)
              {
              return 0;
              }
             if(y>rcClient.bottom-20)
              {
               /* Die Palette */
               y-=rcClient.bottom;
	       xscale=rcClient.right/(ColumnCount+1);
	       x/=xscale;
	       x/=2;
	       x*=2;
	       if((y>-6)&&(!Pairmode)) x++;
               /* x hat jetzt den gewhlten Kanal! */
               if(x<ColumnCount)
	       DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_DIALOG1),
	                      hWnd,Dialog1_DlgProc,x);
               InvalidateRect(hWnd,0,TRUE);
              }
             }
             return 0;

            case WM_LBUTTONDBLCLK:
             {
             char st1[200];
             int x,y,xscale;
             RECT rcClient;
             x=LOWORD(lParam);
             y=HIWORD(lParam);
             GetClientRect(hWnd,&rcClient);
             rcClient.bottom-=40;

             if(!datei)
              {
              return 0;
              }
             if(y>rcClient.bottom-20)
              {
               /* Die Palette */
               y-=rcClient.bottom;
	       xscale=rcClient.right/(ColumnCount+1);
	       x/=xscale;
	       x/=2;
	       x*=2;
	       if((y>-6)&&(!Pairmode)) x++;
               /* x hat jetzt den gewhlten Kanal! */
               if(x<ColumnCount)
               if(Spalten[x].aktiv) Spalten[x].aktiv=0;
               else Spalten[x].aktiv=1;
               InvalidateRect(hWnd,0,TRUE);
              }
             return 0;
             }

            case WM_LBUTTONDOWN:
             {
             char st1[200];
             int x,y,xscale;
             RECT rcClient;
             x=LOWORD(lParam);
             y=HIWORD(lParam);
             GetClientRect(hWnd,&rcClient);
             rcClient.left+=3;
             rcClient.top+=3;
             rcClient.bottom-=40;
             rcClient.right-=3;

             if(!datei)
              {
              return 0;
              }
             if(y>rcClient.bottom-20)
              {
               /* in die Palette geklickt*/
               y-=rcClient.bottom;
	       xscale=rcClient.right/(ColumnCount+1);
	       x/=xscale;
	       x/=2;
	       x*=2;
	       if((y>-6)&&(!Pairmode)) x++;
               /* x hat jetzt den gewhlten Kanal! */
               if(x<ColumnCount)
                { if(aktstift==x) aktstift=-1;
                  else aktstift=x;
                }
               InvalidateRect(hWnd,0,TRUE);
              }
             else
              /* Ins Diagramm geklickt */
              {
               char st1[100];
               float faktor;
               y-=rcClient.bottom-120;
               KlickX=LOWORD(lParam);	/* Die Mauspos brauchen wir noch */
 
               sprintf(st1,"Ypos=%d",y);
//               MessageBox(hWnd,st1,"Hhe",MB_OK);
               
               faktor=10;		/* Maximale Vergrerung */
               if(y>-40) faktor=5;
               if(y>-20) faktor=2;
               if(y>0) faktor=0.5;               
               if(y>20) faktor=0.2;
               if(y>40) faktor=0.1;
                              
               Center(faktor);
                              
              }
             return 0;
             }

  	    case WM_CONTEXTMENU:
             //wParam enthlt das hWnd des Fenster oder Controls!
             {
             HMENU hmenu,hmenuTrack;
             RECT rcWnd;
             KlickX=LOWORD(lParam);	/* Die Mauspos brauchen wir noch */
             /* das ist Bildschirmkoordinate */
             GetWindowRect(hWnd,&rcWnd);
             /* linken Fensterrand abziehen */
             KlickX-=rcWnd.left;
             
             hmenu=LoadMenu(g_hInst,MAKEINTRESOURCE(IDM_MENU2));
             hmenuTrack = GetSubMenu(hmenu, 0);
	      TrackPopupMenuEx(hmenuTrack,
                       TPM_LEFTBUTTON,
                       LOWORD(lParam),HIWORD(lParam),
                       hWnd,
                       NULL);
             DestroyMenu(hmenu);
             return 0;
             }

	   case WM_COMMAND:
	     switch (LOWORD(wParam))
	     {

             case CM_DATEIOEFFNEN:
              {
                OPENFILENAME ofn;
                char FileName[300];
                ZeroMemory(&ofn,sizeof(ofn));
                strcpy(FileName,"*.csv");
                ofn.lStructSize=sizeof(ofn);
                ofn.lpstrFilter="CSV-Dateien\0*.csv\0"
                                "Texttateien\0*.txt\0"
                                "alle Dateien\0*.*\0";
                ofn.hwndOwner=hWnd;
                ofn.lpstrFile=FileName;
                ofn.nMaxFile=300;
                ofn.lpstrTitle="Datei zum ffnen whlen!";
                ofn.Flags=OFN_FILEMUSTEXIST;
	             
                if(GetOpenFileName(&ofn))
                 {
                  FileOpen(FileName);
                 }
               InvalidateRect(hWnd,0,TRUE);
              }
              return 0;
              
             case CM_KLEINER:
              {
              ViewPush();
              Zoom*=2;
              InvalidateRect(hWnd,0,TRUE);
              }
              return 0;
             
             case CM_GROESSER:
              {
              ViewPush();
              if(Zoom>1) Zoom/=2;
              InvalidateRect(hWnd,0,TRUE);
              }
              return 0;  

             case CM_VGROESSER:
              {
              char st1[16],*cp;
              Scale/=2;
              ViewPush();
              sprintf(st1,"%E",Scale);
              if(cp=strchr(st1,'.'))
               {
               cp++;
               while(*cp !='E') 
                {
                *cp='0';
                cp++;
                }
               }
              sscanf(st1,"%E",&Scale); 
              InvalidateRect(hWnd,0,TRUE);
              }
              return 0;
             
             case CM_VKLEINER:
              {
              char st1[16],*cp;
              Scale*=2;
              ViewPush();
              sprintf(st1,"%E",Scale);
              if(cp=strchr(st1,'.'))
               {
               cp++;
               while(*cp !='E') 
                {
                *cp='0';
                cp++;
                }
               }
              sscanf(st1,"%E",&Scale); 
              InvalidateRect(hWnd,0,TRUE);
              }
              return 0;  

             case CM_LEFT:
              {
               RECT rcClient;
               ViewPush(); /* Ansicht speichern */
               /* Halben Bildschirm nach rechts scrollen */
	       GetClientRect(hWnd, &rcClient);
               Aktzeit-=(rcClient.right-60)/2*Zoom;
	       if(Aktzeit<Startzeit) Aktzeit=Startzeit;
               InvalidateRect(hWnd,0,TRUE);
               SetFocus(hWnd);
              return 0;
              }

             case CM_RIGHT:
              {
               RECT rcClient;
               ViewPush(); /* Ansicht speichern */
               /* Halben Bildschirm nach links scrollen */
	       GetClientRect(hWnd, &rcClient);
               Aktzeit+=(rcClient.right-60)/2*Zoom;
	       if(Aktzeit>Endzeit) Aktzeit=Endzeit;
               InvalidateRect(hWnd,0,TRUE);	       
               SetFocus(hWnd);
              return 0;
              }

             case CM_UP:
              {
               ViewPush(); /* Ansicht speichern */
	       offset+=Scale/10;	       
               InvalidateRect(hWnd,0,TRUE);	       
               SetFocus(hWnd);
              return 0;
              }

             case CM_DOWN:
              {
               ViewPush(); /* Ansicht speichern */
	       offset-=Scale/10;	       
               InvalidateRect(hWnd,0,TRUE);	       
               SetFocus(hWnd);
              return 0;
              }
              
             case CM_TOTAL:
              {
               RECT rcClient;
               time_t laenge;
               
               ViewPush(); /* Ansicht speichern */
               Aktzeit=Startzeit;
	       laenge=Endzeit-Startzeit;
	       /*Bildschirmgre ermitteln*/
	       GetClientRect(hWnd, &rcClient);
               Zoom=laenge/(rcClient.right-60);
               InvalidateRect(hWnd,0,TRUE);
               return 0;
              }
             case CM_MANUAL:
              {
              char *cp,st1[300];
              GetModuleFileName(NULL,st1,290);
              if(cp=strrchr(st1,'.'))
               {
               strcpy(cp,".pdf");
               MessageBox(hWnd,st1,"versuche zu ffnen",MB_OK);
               ShellExecute(
		0,
		"open",
		st1,
		NULL,
		"",
		SW_RESTORE);
               }
              return 0;
              }

	     case CM_DATEIBEENDEN:
	      {
	       FileClose();
	       SendMessage(hWnd,WM_DESTROY,0,0);
	       return 0;
	      }
	     
	     case CM_SAVEPALETTE:
	      {
	       OPENFILENAME ofn;
	       char FileName[300];
	       FileName[0]=0;
               ZeroMemory(&ofn,sizeof(ofn));   	
               ofn.lStructSize=sizeof(ofn);
	       ofn.hwndOwner=hWnd;
	       ofn.lpstrFile=FileName;
	       ofn.lpstrFilter="CSV-Dateien\0*.csv\0Textdateien\0*.txt\0alle Dateien\0*.*\0\0\0";
	       ofn.lpstrDefExt="csv";
	       ofn.nMaxFile=300;
	       ofn.lpstrTitle="Datei zum Empfangen whlen!";
	       ofn.Flags=0;
	       if(GetSaveFileName(&ofn))
                {
                int a;
                FILE *datei;
                datei=fopen(FileName,"w");
                if(datei)
                 {
                 for(a=0;a<ColumnCount;a++)
                  {
                  fprintf(datei,"%s#%08X#%d#%s\n",Spalten[a].name,
                                             Spalten[a].farbe,
                                             Spalten[a].aktiv,
                                             Spalten[a].einheit);
                  }
                 fclose(datei);
                 }
                }
	      return 0;
	      }  

             case CM_LIZENZ:
              {
       	       DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_DIALOG2),
                      hWnd,Dialog2_DlgProc,0);
              return 0;
              }

             case CM_HELP:
              {
              Hilfe();
              return 0;
              }
              
             case CM_SETUP:
              {
       	       DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_DIALOG3),
                      hWnd,Dialog3_DlgProc,0);              
              return 0;
              }
              
             case CM_GOTO:
              {
               ViewPush(); /* Ansicht speichern */
       	       DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_GOTO),
                      hWnd,Dialog4_DlgProc,0);                            
              return 0;
              }

             case CM_CENTER:
              {
              Center(1);
              return 0;
              } 

             case CM_BACK:
              {
              ViewPop();
              return 0;
              } 

             case CM_DRUCKEN:
              {
               DOCINFO di;
               DEVMODE *dm;
               HANDLE hdc;
               PRINTDLG dlg;
               RECT rcClient;
               char st1[200];
               
               memset(&di,0,sizeof(di));
               memset(&dlg,0,sizeof(dlg));

	       MessageBox(hWnd,"Die Druckfunktion befindet sich noch im frhen Entwicklungsstadium!\n"
	                       "Um den Wald zu schonen wird empfohlen das Programm PDFCreator zum Testen zu benutzen.",
	                       "Achtung!",MB_OK);
               dlg.lStructSize=sizeof(dlg);
               dlg.hwndOwner=hWnd;
               dlg.Flags=PD_RETURNDC;

               if(PrintDlg(&dlg))
                {
                /* den DC auf Querformat umprogrammieren */
                dm=GlobalLock(dlg.hDevMode);
                dm->dmOrientation=DMORIENT_LANDSCAPE;
                ResetDC(dlg.hDC,dm);
                GlobalUnlock(dlg.hDevMode);

                hdc=dlg.hDC;
                di.cbSize = sizeof(DOCINFO); 
                di.lpszDocName = "Diagramm"; 
                di.lpszOutput = (LPTSTR) NULL; 
                di.fwType = 0; 
                StartDoc(hdc, &di);               
                StartPage(hdc);

		rcClient.left=250;
		rcClient.top=250;
		rcClient.bottom=GetDeviceCaps(hdc,VERTRES)-250;
		rcClient.right=GetDeviceCaps(hdc,HORZRES)-250;

                Paint(hdc,rcClient);
                EndPage(hdc);
                EndDoc(hdc);

                DeleteDC(hdc);
                }
              return 0;
              }
             case CM_MESSEN:
              {
              char st1[2000],tempfilename[350],*cp;
              struct tm t,*pTime;
              time_t t1,t2;
              int a,jahr,monat;
              FILE *tempfile;
              double v;

              GetModuleFileName(0,tempfilename,340);
              if (cp=strrchr(tempfilename,'.')) strcpy(cp,"_tmp.txt");
              tempfile=fopen(tempfilename,"w");

              /* Uhrzeit der Klickpos errechnen */
              a=KlickX-63; /* Der Rahmen gehrt auch dazu */
              t2=Aktzeit+(a*Zoom);
              
              /* Stelle in der Datei aufsuchen */
             rewind (datei);
             fgets(st1,1490,datei); /* Die Kopfzeile haben wir schon */

             /* bis zur Startposition vorspulen */
                do
                 {
                  memset(st1,0,1490);
                  memset(&t,0,sizeof(t));
                  fgets(st1,1490,datei); /* eine Zeile einlesen */
		  /* Zeitstempel lesen */
		  sscanf(st1,"%d.%d.%d;%d:%d:%d",&t.tm_mday,&monat,&jahr,
				  &t.tm_hour,&t.tm_min,&t.tm_sec);
		  t.tm_mon=monat-1;
                  t.tm_year=jahr-1900;
                  t.tm_isdst=-1;
                  t1=mktime(&t);
                 }
                while ((t1<t2)&&(!feof(datei)));

              /* Werte auswerten */
              
              pTime=localtime(&t2);
              fprintf(tempfile,"geklickt %02d.%02d.%04d %02d:%02d:%02d\n"
                               ,pTime->tm_mday,
                                               pTime->tm_mon+1,
                                               pTime->tm_year+1900,
					       pTime->tm_hour,
                                               pTime->tm_min,
                                               pTime->tm_sec);
              pTime=localtime(&t1);
              fprintf(tempfile,"gefunden %02d.%02d.%04d %02d:%02d:%02d\n"
                               "============================\n",pTime->tm_mday,
                                               pTime->tm_mon+1,
                                               pTime->tm_year+1900,
					       pTime->tm_hour,
                                               pTime->tm_min,
                                               pTime->tm_sec);
              /* Kommas in Punkte umwandeln */
              cp=st1;
              while (cp=strchr(cp,',')) *cp='.';
              if(cp=strchr(st1,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/

              cp=strchr(st1,';')+1;   /* das ist die Zeit */

                 for(a=0;a<ColumnCount;a++)
                  {
                   cp=strchr(cp,';');
                   if(cp)
                    {
                    cp++;
                    if(Spalten[a].aktiv)
                    {
                    v=1234.56;
                    sscanf(cp,"%lf",&v);
                    fprintf(tempfile,"%s = %lf %s\n",Spalten[a].name,v,Spalten[a].einheit);
                    }
                   }
                   else a=ColumnCount;
                  }
              
              
              fclose(tempfile);
              ShellExecute(0,"open",tempfilename,NULL,"",SW_RESTORE);
              return 0;
              }
	     }
            return 0;
	   default:
	     return DefWindowProc (hWnd, uiMessage, wParam, lParam);  
	  }
	}






BOOL WINAPI Dialog1_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   static int Spalte;
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
       Spalte=lParam;
       SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON1)));
       SendMessage(hWnd,WM_SETTEXT,0,(LPARAM) Spalten[Spalte].name);
       SendMessage(GetDlgItem(hWnd,IDC_EDIT1),WM_SETTEXT,0,(LPARAM) Spalten[Spalte].name);
       SendMessage(GetDlgItem(hWnd,IDC_UNIT),WM_SETTEXT,0,(LPARAM) Spalten[Spalte].einheit);
       if(Spalten[Spalte].aktiv) SendMessage(GetDlgItem(hWnd,IDC_VISIBLE),BM_SETCHECK,BST_CHECKED,0);
       else SendMessage(GetDlgItem(hWnd,IDC_VISIBLE),BM_SETCHECK,BST_UNCHECKED,0);
       if(Pairmode) SendMessage(GetDlgItem(hWnd,IDC_PAIRMODE),BM_SETCHECK,BST_CHECKED,0);
       else SendMessage(GetDlgItem(hWnd,IDC_PAIRMODE),BM_SETCHECK,BST_UNCHECKED,0);
      }
      break;
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
       case IDC_OK:
        {
         char st1[100];
         /* Eingegebene Werte speichern */

         SendMessage(GetDlgItem(hWnd,IDC_EDIT1),WM_GETTEXT,20,(LPARAM) Spalten[Spalte].name);
         SendMessage(GetDlgItem(hWnd,IDC_UNIT),WM_GETTEXT,20,(LPARAM) Spalten[Spalte].einheit);
         if(SendMessage(GetDlgItem(hWnd,IDC_VISIBLE),BM_GETCHECK,0,0)==BST_CHECKED)
          Spalten[Spalte].aktiv=1;
         else
          Spalten[Spalte].aktiv=0;
         if(SendMessage(GetDlgItem(hWnd,IDC_PAIRMODE),BM_GETCHECK,0,0)==BST_CHECKED)
          Pairmode=1;
         else
          Pairmode=0;
         EndDialog(hWnd,1);
        }
        break;
        
       case IDC_COLORSEL:
        {
        CHOOSECOLOR chk;
        COLORREF cc[16];
        ZeroMemory(&chk,sizeof(chk));
        chk.lStructSize=sizeof(chk);
        chk.hwndOwner=hWnd;
        chk.rgbResult=Spalten[Spalte].farbe;
        chk.lpCustColors=cc;
        chk.Flags=CC_RGBINIT;
        if(ChooseColor(&chk)) Spalten[Spalte].farbe=chk.rgbResult;
        }
        break;
       
       case IDC_OTHERSOFF:
        {
        int a;
        for(a=0;a<ColumnCount;a++)
         {
         if(a!=Spalte) Spalten[a].aktiv=0;
         }
        SendMessage(GetDlgItem(hWnd,IDC_VISIBLE),BM_SETCHECK,BST_CHECKED,0); 
        }
        break;
                
       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,0);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }


BOOL WINAPI Dialog2_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
      char st1[65536],*cp,*cp1;
      FILE *datei;
      SendMessage(hWnd,WM_SETTEXT,0,(LPARAM) "Lizenzinformationen");
      GetModuleFileName(0,st1,290);
      cp=strrchr(st1,'\\');     /* wollen nur das Verzeichnis */
      if(cp) strcpy(cp,"\\gpl.txt");
      datei=fopen(st1,"rb");
      if(datei)
      {
      cp=st1;
      while(!feof(datei))
       {
       fgets(cp,200,datei);
       if(cp1=strchr(cp,13)) *cp1=0;
       strcat(cp,"\r\n");
       cp+=strlen(cp);
       }
      fclose(datei);
      cp=st1;
//      while(cp=strchr(cp,10)) *cp=13;
      }
      SendMessage(GetDlgItem(hWnd,IDC_DLG2_EDIT),WM_SETTEXT,0,(LPARAM) st1);
      }
      break;
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
       case IDC_DLG2_OK:
        {
         EndDialog(hWnd,1);
        }
        break;                        
       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,0);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }

BOOL WINAPI Dialog3_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
      char st1[200];
      sprintf(st1,"%d",littlestep);
      SendMessage(GetDlgItem(hWnd,IDC_LITTLESTEP),WM_SETTEXT,0,(LPARAM) st1);
      sprintf(st1,"%d",bigstep);
      SendMessage(GetDlgItem(hWnd,IDC_BIGSTEP),WM_SETTEXT,0,(LPARAM) st1);
      sprintf(st1,"%d",Zoom);
      SendMessage(GetDlgItem(hWnd,IDC_HZOOM),WM_SETTEXT,0,(LPARAM) st1);
      sprintf(st1,"%f",Scale);
      SendMessage(GetDlgItem(hWnd,IDC_VZOOM),WM_SETTEXT,0,(LPARAM) st1);
      sprintf(st1,"%f",offset);
      SendMessage(GetDlgItem(hWnd,IDC_OFFSET),WM_SETTEXT,0,(LPARAM) st1);

      SetFocus(GetDlgItem(hWnd,IDOK));
      }
      break;
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
       case IDOK:
        {
         char st1[200];
         SendMessage(GetDlgItem(hWnd,IDC_LITTLESTEP),WM_GETTEXT,190,(LPARAM) st1);
         sscanf(st1,"%d",&littlestep);
         SendMessage(GetDlgItem(hWnd,IDC_BIGSTEP),WM_GETTEXT,190,(LPARAM) st1);
         sscanf(st1,"%d",&bigstep);
         SendMessage(GetDlgItem(hWnd,IDC_HZOOM),WM_GETTEXT,190,(LPARAM) st1);
         sscanf(st1,"%d",&Zoom);        
         SendMessage(GetDlgItem(hWnd,IDC_VZOOM),WM_GETTEXT,190,(LPARAM) st1);
         sscanf(st1,"%f",&Scale);        
         SendMessage(GetDlgItem(hWnd,IDC_OFFSET),WM_GETTEXT,190,(LPARAM) st1);
         sscanf(st1,"%f",&offset);        
         InvalidateRect(g_hWnd,0,TRUE);
         EndDialog(hWnd,1);
        }
        break;                        
       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,0);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }


BOOL WINAPI Dialog4_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
      char st1[200];
      struct tm *tmBuf;
      
      tmBuf=localtime(&Aktzeit);
      sprintf(st1,"%02d.%02d.%04d",
                tmBuf->tm_mday,tmBuf->tm_mon+1,tmBuf->tm_year+1900);
      SendMessage(GetDlgItem(hWnd,IDC_DATE),WM_SETTEXT,0,(LPARAM) st1);
      sprintf(st1,"%02d:%02d:%02d",
                tmBuf->tm_hour,tmBuf->tm_min,tmBuf->tm_sec);
      SendMessage(GetDlgItem(hWnd,IDC_TIME),WM_SETTEXT,0,(LPARAM) st1);
      SetFocus(GetDlgItem(hWnd,IDOK));
      }
      break;
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
       case IDOK:
        {
         int monat,jahr;
         char st1[200];
         struct tm t;
         time_t t1;
         memset(&t,0,sizeof(t));
         SendMessage(GetDlgItem(hWnd,IDC_DATE),WM_GETTEXT,190,(LPARAM) st1);
                  sscanf(st1,"%d.%d.%d",&t.tm_mday,&monat,&jahr);

         SendMessage(GetDlgItem(hWnd,IDC_TIME),WM_GETTEXT,190,(LPARAM) st1);
         sscanf(st1,"%d:%d:%d",&t.tm_hour,&t.tm_min,&t.tm_sec);
         t.tm_mon=monat-1;
         t.tm_year=jahr-1900;
         t.tm_isdst=-1;
         t1=mktime(&t);
         if((t1<Startzeit)||(t1>Endzeit))
          {
          MessageBox(hWnd,"Uhrzeit nicht innerhalb der Aufzeichnung!","Fehler",MB_OK);
          return 0;
          }
         Aktzeit=t1;
         InvalidateRect(g_hWnd,0,TRUE);
         EndDialog(hWnd,1);
        }
        break;                        
       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,0);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }
